#include "SoftwareSerial.h"
#include "Adafruit_Thermal.h"
#include "Smile_image.h"

int printer_RX_Pin = 5;  // this is the green wire
int printer_TX_Pin = 6;  // this is the yellow wire
boolean printing = false;
Adafruit_Thermal printer(printer_RX_Pin, printer_TX_Pin);
int nextChar;

char* intensityValues[]={"Diva", "Hipster", "Ninja",
"Rockstar", "Princess","Lion", "Bunny", "Horse", "Original smiley", "Baby"};

char* teethValues[]={"Winter white", "Vanilla ice", "Sea pearl",
"Bone white", "Fog grey","Birch","Cloud gray","Coconut white","Eggshell white","Marshmallow","Mayonnaise"};

char* impactValues[]={"Extreme", "Overwhelming", "Blinding", "Outstanding", "You're like Sunshine", "Fabulous","Smart", "Mindblowing", "Foolish", "Inspiring" };

void setup(){
  Serial.begin(9600);
} 

void printReceipt() {
   printer.begin();

  printer.println();
  printer.inverseOn(); 
  printer.doubleHeightOn(); 
  printer.println("Your Personal Smile Report");
  printer.doubleHeightOff(); 
  printer.inverseOff();  
  printer.justify('L'); 
  printer.println("Even a fake smile is a healthy \n smile! :) ");
  printer.println();
  printer.justify('C'); 
  printer.println("*****************************");
  printer.justify('L');
  
  int randNumber = random(0, 9);
  String intensityString = "Intensity of Smile: ";
  String intensityValue = intensityValues[randNumber];
  intensityString += intensityValue;
  
  printer.println(intensityString);
  
  int randNumber2 = random(0, 10);
  String teethString = "Color of teeth: ";
  String teethValue = teethValues[randNumber];
  teethString += teethValue;
  
  printer.println(teethString);
  int randNumber3 = random(0, 9);
  String impactString = "Smile impact on Others:";
  String impactValue = impactValues[randNumber];
  impactString += impactValue;
  
  printer.println(impactString);
  printer.boldOn();
  printer.justify('C'); 
  printer.println("*****************************");
  printer.println();
  printer.justify('L');
  printer.println("Daily smiling can prolong your \n life. Remember to keep smiling!");
  printer.println("\n");
  
  printer.printBitmap(smile_logo_for_report_width, smile_logo_for_report_height, smile_logo_for_report_data);
  printer.println("\n\n");
  printer.sleep(); //Tell printer to sleep. MUST call wake before printing again, even if reset
  printer.wake(); //Wake printer.
  printer.setDefault(); //set printer to defaults. ****WILL FEED SEVERAL LINES WHEN CALLED***
}

void loop(){
 if (Serial.available()) {
    nextChar = Serial.read();
    if (nextChar == '0') {
      if (printing == false) {
        delay(5000); // prints
        printReceipt();
      }
    }
  }
}
